Get a quote

Requests a quote according to the specified swap parameters. This endpoint may be used to get a quote for a swap, a bridge, or a wrap/unwrap. The resulting response includes a quote for the swap and the proposed route by which the quote was achieved. The response will also include estimated gas fees for the proposed quote route. If the proposed route is via a Uniswap Protocol pool, the response may include a permit2 message for the swapper to sign prior to making a /swap request. The proposed route will also be simulated. If the simulation fails, the response will include an error message or txFailureReason.

Certain routing options may be whitelisted by the requestor through the use of the protocols field. Further, the requestor may ask for the best price route or for the fastest price route through the 'routingPreference' field. Note that the fastest price route refers to the speed with which a quote is returned, not the number of transactions that may be required to get from the input token and chain to the output token and chain. Further note that all routingPreference values except for FASTEST and BEST_PRICE are deprecated. For more information on the protocols and routingPreference fields, see the Token Trading Workflow explanation of Swap Routing.

API integrators using this API for the benefit of customer end users may request a service fee be taken from the output token and deposited to a fee collection address. To request this, please reach out to your Uniswap Labs contact. This optional fee is associated to the API key and is always taken from the output token. Note if there is a fee and the type is EXACT_INPUT, the output amount quoted will not include the fee subtraction. If there is a fee and the type is EXACT_OUTPUT, the input amount quoted will not include the fee addition. Instead, in both cases, the fee will be recorded in the portionBips and portionAmount fields.

Recent Requests
Log in to see full request history
TimeStatusUser Agent
Retrieving recent requests…
LoadingLoading…
Body Params
string
enum
required

The handling of the amount field. EXACT_INPUT means the requester will send the specified amount of input tokens and get a quote with a variable quantity of output tokens. EXACT_OUTPUT means the requester will receive the specified amount of output tokens and get a quote with a variable quantity of input tokens.

Allowed:
string
required

The quantity of tokens denominated in the token's base units. (For example, for an ERC20 token one token is 1x10^18 base units. For one USDC token one token is 1x10^6 base units.) This value must be greater than 0.

number
enum
required

The unique ID of the blockchain. For a list of supported chains see the FAQ.

number
enum
required

The unique ID of the blockchain. For a list of supported chains see the FAQ.

string
required

The token which will be sent, specified by its token address. For a list of supported tokens, see the FAQ.

string
required

The token which will be received, specified by its token address. For a list of supported tokens, see the FAQ.

boolean
Defaults to false

Dictates whether you receive permits to sign or permit approval transactions to submit onchain for your wallet in order to swap or LP. If set to true, the response will include an approval transaction depending on your allowance. If set to false you would receive a permit to sign depending on your allowance. The default is false.

string
required

The wallet address which will be used to send the token.

number

The slippage tollerace as a percentage up to a maximum of two decimal places. For Uniswap Protocols (v2, v3, v4), the slippage tolerance is the maximum amount the price can change between the time the transaction is submitted and the time it is executed. The slippage tolerance is a percentage of the total value of the swap.

When submitting a quote, note that slippage tolerance works differently in UniswapX swaps where it does not set a limit on the Spread in an order. See here for more information.

Note that if the trade type is EXACT_INPUT, then the slippage is in terms of the output token. If the trade type is EXACT_OUTPUT, then the slippage is in terms of the input token.

When submitting a request, slippageTolerance may not be set when autoSlippage is defined. One of slippageTolerance or autoSlippage must be defined.

string
enum
Defaults to undefined

The auto slippage strategy to employ. For Uniswap Protocols (v2, v3, v4) the auto slippage will be automatically calculated when this field is set to DEFAULT. Auto slippage cannot be calculated for UniswapX swaps.

Note that if the trade type is EXACT_INPUT, then the slippage is in terms of the output token. If the trade type is EXACT_OUTPUT, then the slippage is in terms of the input token.

When submitting a request, autoSlippage may not be set when slippageTolerance is defined. One of slippageTolerance or autoSlippage must be defined.

Allowed:
string
enum
Defaults to BEST_PRICE

The routingPreference specifies the preferred strategy to determine the quote. If the routingPreference is BEST_PRICE, then the quote will propose a route through the specified whitelisted protocols (or all, if none are specified) that provides the best price. When the routingPreference is FASTEST, the quote will propose the first route which is found to complete the swap. Note that the values CLASSIC, UNISWAPX, BEST_PRICE_V2, UNISWAPX_V2, V3_ONLY, and V2_ONLY are deprecated and will be removed in a future release. See the Token Trading Workflow page for more information.

protocols
array of objects

The protocols to use for the swap/order. If the protocols field is defined, then you can only set the routingPreference to BEST_PRICE. Note that the value UNISWAPX is deprecated and will be removed in a future release.

protocols
string
enum

The hook options to use for V4 pool quotes. V4_HOOKS_INCLUSIVE will get quotes for V4 pools with or without hooks. V4_HOOKS_ONLY will only get quotes for V4 pools with hooks. V4_NO_HOOKS will only get quotes for V4 pools without hooks. Defaults to V4_HOOKS_INCLUSIVE if V4 is included in protocols and hookOptions is not set. This field is ignored if V4 is not passed in protocols.

Allowed:
string
enum
Defaults to EXECUTION

For UniswapX swaps, when set to EXECUTION, quotes optimize for looser spreads at higher fill rates. When set to PRICE, quotes optimize for tighter spreads at lower fill rates. This field is not applicable to Uniswap Protocols (v2, v3, v4), bridging, or wrapping/unwrapping and will be ignored if set.

Allowed:
string
enum
Defaults to urgent

The urgency impacts the estimated gas price of the transaction. The higher the urgency, the higher the gas price, and the faster the transaction is likely to be selected from the mempool. The default value is urgent.

Allowed:
string
enum
Defaults to FULL

For Uniswap Protocols (v2, v3, v4) swaps, specify the input token spend allowance (e.g. quantity) to be set in the permit. FULL can be used to specify an unlimited token quantity, and may prevent the wallet from needing to sign another permit for the same token in the future. EXACT can be used to specify the exact input token quantity for this request. Defaults to FULL.

Allowed:
Headers
string
enum
Defaults to 2.0

The version of the Universal Router to use for the swap journey. MUST be consistent throughout the API calls.

Allowed:
Responses

Language
Credentials
Header
URL
LoadingLoading…
Response
Click Try It! to start a request and see the response here! Or choose an example:
application/json